package pl.com.example.mavenproject1.web2;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.annotations.Widgetset;
import com.vaadin.cdi.CDIUI;
import com.vaadin.cdi.server.VaadinCDIServlet;
import com.vaadin.server.VaadinRequest;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;
import javax.ejb.EJB;
import javax.servlet.annotation.WebInitParam;
import pl.com.example.TestBean;

/**
 *
 */
@Theme("mytheme")
@Widgetset("pl.com.example.mavenproject1.web2.MyAppWidgetset")
@CDIUI("")
public class MyUI extends UI {

    @EJB TestBean testBean;
    
    @Override
    protected void init(VaadinRequest vaadinRequest) {
        final VerticalLayout layout = new VerticalLayout();
        layout.setMargin(true);
        setContent(layout);

        Button button = new Button("Click Me");
        button.addClickListener((ClickEvent event) -> {
            layout.addComponent(new Label(testBean.getTestMsg()));
        });
        layout.addComponent(button);

    }

    @WebServlet(urlPatterns = "/*", name = "MyUIServlet2", asyncSupported = true, initParams = {
        @WebInitParam(name = "UIProvider", value = "com.vaadin.cdi.CDIUIProvider")})
    @VaadinServletConfiguration(ui = MyUI.class, productionMode = false)
    public static class MyUIServlet2 extends VaadinCDIServlet {
    }
}